<template lang="pug">
.field.is-grouped( v-if='editor' )
	.control.is-flex
		.buttons.is-flex
			label.button.is-small.is-primary.is-light( title="Прикрепить изображения" )
				span.icon.is-small
					input.is-hidden( type="file" multiple @input='handleInput($event, "images")' )
					i.fa-solid.fa-image

			label.button.is-small.is-info.is-light( title="Прикрепить файлы" )
				span.icon.is-small
					input.is-hidden( type="file" multiple @input='handleInput($event, "files")' )
					i.fa-solid.fa-file

			.button.is-small( title="ctrl + B" @click='editor.chain().focus().toggleBold().run()' :class='{ "is-black": editor.isActive("bold") }' )
				span.has-text-weight-bold B

			.button.is-small( title="ctrl + I" @click='editor.chain().focus().toggleItalic().run()' :class='{ "is-black": editor.isActive("italic") }' )
				span.is-italic I
	.control.is-expanded
		BField( :label='label' :on-border='onBorder' )
			.picker
				.picker-trigger
					span.icon
						i.fa-solid.fa-face-smile
				.picker-body
					emoji-picker( @select='editor.commands.insertContent($event.i)' )
			editor-content( :editor='editor' )
</template>

<script setup>
import EmojiPicker from "vue3-emoji-picker"
import "@/../node_modules/vue3-emoji-picker/dist/style.css"

import { nextTick, onMounted, ref, watch } from "vue"

import { Editor, EditorContent } from "@tiptap/vue-3"
import StarterKit from "@tiptap/starter-kit"

import BField from "@/components/form/Field.vue"
import { useToast } from "vue-toastification"

const props = defineProps({ 
	modelValue: {
		type: Object,
		default: () => ({})
	},
	label: {
		type: String,
		default: ""
	},
	noSubmit: Boolean,
	onBorder: Boolean
})
const emit = defineEmits(["update:modelValue", "submit"])

const toast = useToast()

const editor = ref()
const htmlData = ref("")
const imagesOnUpload = ref([])
const filesOnUpload = ref([])

const upd = ({ editor }) => {
	const html = editor.getHTML()
	htmlData.value = html
	emit("update:modelValue", { 
		data: html == "<p></p>" ? "" : html, 
		images: imagesOnUpload.value,
		files: filesOnUpload.value
	})
}

watch([ imagesOnUpload, filesOnUpload ], () => emit("update:modelValue", {
	data: htmlData.value == "<p></p>" ? "" : htmlData.value, 
	images: imagesOnUpload.value,
	files: filesOnUpload.value
}))

const handleInput = ({ target: { files } }, bucket) => {
	let hasInvalidImage = false
	let hasInvalidFile = false
	const data = Object.keys(files).map(i => files[i]).filter(file => {
		if (bucket == "files") {
			const valid = ["image/gif", "application/pdf", "application/zip", "application/octet-stream", "application/x-zip-compressed", "multipart/x-zip"].includes(file.type)

			if (!valid) hasInvalidFile = true

			return valid
		}

		const valid = [ "image/jpeg", "image/png", "image/webp" ].includes(file.type)
		
		if (!valid) hasInvalidImage = true

		return valid
	})

	if (hasInvalidImage) toast.error("Допускаются только изображения jpeg, png и webp формата")
	if (hasInvalidFile) toast.error("Допускаются только файлы .gif, .pdf, .zip")

	if (bucket == "images")
		imagesOnUpload.value = data
	else
		filesOnUpload.value = data
}

const clear = () => {
	editor.value.commands.clearContent(true)
	imagesOnUpload.value = []
	filesOnUpload.value = []
}

watch(() => props.modelValue, nv => {
	if (!Object.keys(nv).length) return clear()
})

const keys = []
let i = 0
onMounted(() => {
	editor.value = new Editor({
		extensions: [ StarterKit ],
		content: props.modelValue?.data || "",
		editorProps: {
			attributes: {
				class: "textarea content"
			},
			handleKeyDown: (view, e) => {
				if (props.noSubmit) return

				keys[i] = e.key

				if (i == 1)
					i--
				else
					i++

				if ((keys[0] == "Control" && keys[1] == "Enter") || (keys[0] == "Enter" && keys[1] == "Control")) {
					keys.length = 0
					emit("submit")
				}
				
				return false
			}
		},
		onUpdate: upd,
		onCreate: upd
	})
})
</script>

<style lang="scss" scoped>
.field {
	&:deep(.textarea) {
		max-height: unset;
		height: auto;
		min-height: 3rem;
		border-radius: 2px;
		padding-right: 2rem;
		p:not(:last-child) {
			margin-bottom: 0;
		}
	}
}

.buttons {
	align-items: stretch;
}

.button {
	height: unset;
	max-height: 3rem;
}

.picker {
	position: absolute;
	top: .5rem;
	right: .5rem;
	z-index: 2;
	&-trigger {
		cursor: pointer;
	}
	&-body {
		max-height: 0;
		overflow: hidden;
		position: absolute;
		bottom: 100%;
		right: 0;
		transition: max-height .2s ease-in-out;
	}
	&:hover {
		.picker-body {
			max-height: 320px;
		}
	}
}
</style>